﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Media;
using System.Collections;

namespace ZavrsniRad
{
    class Entity:IComparable
    {
#region varijable
        NeuralNetwork _nn;

        public NeuralNetwork Nn
        {
            get { return _nn; }
            set { _nn = value; }
        }

        private double _energyConsumed;

        public double EnergyConsumed
        {
            get { return _energyConsumed; }
            set { _energyConsumed = value; }
        }

        private double _energyDepleted;

        public double EnergyDepleted
        {
            get { return _energyDepleted; }
            set { _energyDepleted = value; }
        }
        private List<double> outputs;

        private double _energyFromOtherEntitys;

        public double EnergyFromOtherEntitys
        {
            get { return _energyFromOtherEntitys; }
            set { _energyFromOtherEntitys = value; }
        }

        public double Fitness
        {
            get { return (this.EnergyConsumed); }
        }

        private float pocetniKut;
        private float _angleOfMovement;
        private Vector2 pomak;
        private double _energy;
        private double _rotatingSpeed;
        private double _forwardSpeed;

        public double Energy
        {
            get { return _energy; }
            set { _energy = value; }
        }

        public float AngleOfMovement
        {
            get { return _angleOfMovement; }
            set { _angleOfMovement = value % 360; }
        }

        private Vector2 _EntityPosition;

        public Vector2 EntityPosition
        {
            get { return _EntityPosition; }
            set { _EntityPosition = value; }
        }

        public void PozicijaX(float x)
        {
            _EntityPosition.X = x;
        }
        public void PozicijaY(float y)
        {
            _EntityPosition.Y = y;
        }
        
#endregion

        public Entity(Vector2 pozicija, float kut, double energy, double rotatingSpeed, double forwardSpeed)
        {
            this.EnergyFromOtherEntitys = 0;
            this.EnergyConsumed = 0;
            this.EnergyDepleted = 0;
            this._rotatingSpeed = rotatingSpeed;
            this._forwardSpeed = forwardSpeed;
            this._energy = energy;
            outputs = new List<double>();
            _EntityPosition = pozicija;
            AngleOfMovement = kut;
            pocetniKut = kut;
        }

        #region akcije dostupne entitetu

        public double MeatToVegetableRatio()
        {
            return this.EnergyFromOtherEntitys / this.EnergyConsumed;
        }
        public void RotateRight(double input)
        {
            this.AngleOfMovement += (float)(input * _rotatingSpeed);
        }

        public void RotateLeft(double input)
        {
            this.AngleOfMovement -= (float)(input * _rotatingSpeed);
        }

        public void Move(double input)
        {
            pomak.X = (float)(Math.Cos(MathHelper.ToRadians(this.AngleOfMovement - 90)) * _forwardSpeed * input);
            pomak.Y = (float)(Math.Sin(MathHelper.ToRadians(this.AngleOfMovement - 90)) * _forwardSpeed * input);
            this.EntityPosition += pomak;
        }
     
        public void ThinkAndAct(List<double> inputs)
        {
            outputs = Nn.CalculateOutput(inputs);
            if (outputs.Count() == 3)
            {
                this.RotateRight(outputs[0]);
                this.RotateLeft(outputs[1]); 
                this.Move(outputs[2]); 
            }
        }

        public int CompareTo(object obj)
        {
            if (obj == null) return -1;
            Entity otherEntity = obj as Entity;
            if (otherEntity != null)
                return otherEntity.EnergyConsumed.CompareTo(this.EnergyConsumed);
            else
                throw new ArgumentException("Object is not a Entity");
            
        }
        #endregion
    }
}
